<!-- GENERATED BY A EUPHORIA PROGRAM. DO NOT EDIT! -->


<html>
<head><title>Euphoria Trouble-Shooting Guide</title>
<style type="text/css">
<!--
body        {background-color: "#FFFFFF";}
a           {text-decoration: none;}
a:link      {color: "#0033BB"; text-decoration: underline;}
a:visited   {color: "#006699"; text-decoration: underline;}
a:active    {color: red; text-decoration: underline;}
a:hover     {color: red; text-decoration: underline;}
a.blue    {text-decoration: none;}
a.blue:link      {color: "#5500FF"; text-decoration: underline;}
a.blue:visited   {color: "#5500FF"; text-decoration: underline;}
a.blue:active    {color: red; text-decoration: underline;}
a.blue:hover     {color: red; text-decoration: underline;}
a.brown      {text-decoration: none;}
a.brown:link      {color: "#993333"; text-decoration: underline;}
a.brown:visited   {color: "#993333"; text-decoration: underline;}
a.brown:active    {color: red; text-decoration: underline;}
a.brown:hover     {color: red; text-decoration: underline;}
-->
</style>

</head>
<body bgcolor="#FFFFFF" link="#0033BB" vlink="#006699">
<table width=90% border=0><tr><td>

<center><font face="Arial, Helvetica" color="#FF0099" size=+2>
<br>
 Euphoria Trouble-Shooting Guide
</font></center>
<p>&nbsp;<br>
<font face="Arial, Helvetica" color="#003366">
<b>If you get stuck, here are some things you can do:</b></font>
<p>
 <table border=0 cellspacing=2 cellpadding=2>
 
<tr><td width=24 nowrap></td><td valign=top><b>1.</b></td>
<td width=10 align=center valign=top>-</td>
<td>Type: <font color="#993333"><b>guru</b></font><br>
   followed by some keywords associated with your problem.
   <p>
   For example,<br>
   <b>guru declare global include</b></td></tr>

 
<tr><td width=24 nowrap></td><td valign=top><b>2.</b></td>
<td width=10 align=center valign=top>-</td>
<td>Check the list of common problems
   (<a href="trouble.htm#commonp">below</a>).</td></tr>

 
<tr><td width=24 nowrap></td><td valign=top><b>3.</b></td>
<td width=10 align=center valign=top>-</td>
<td>Read the relevant parts of the documentation, i.e.
  <a class="blue" href="refman.htm"><b>refman.doc</b></a>
  or
<a class="blue" href="library.htm"><b>library.doc</b></a>.</td></tr>

 
<tr><td width=24 nowrap></td><td valign=top><b>4.</b></td>
<td width=10 align=center valign=top>-</td>
<td>Try running your program with the statements:</td></tr>

<tr><td></td><td></td><td></td><td>
<pre><font color="#0000FF">        with </font><font color="#FF00FF">trace</font>
<font color="#FF00FF">        trace</font><font color="#330033">(1)</font>
</pre></td></tr>


<tr><td width=24 nowrap></td><td valign=top><b></b></td>
<td align=center valign=top></td>
<td>at the top of your main <b>.ex</b> file so you can see
   what's going on.</td></tr>


<tr><td width=24 nowrap></td><td valign=top><b>5.</b></td>
<td width=10 align=center valign=top>-</td>
<td>The <a href=http://www.RapidEuphoria.com/listserv.htm>
  <b>Euphoria mailing list</b></a> has
   a search facility. You can search the archive of all previous messages.
   There's a good chance that your question has already been discussed.</td></tr>


<tr><td width=24 nowrap></td><td valign=top><b>6.</b></td>
<td width=10 align=center valign=top>-</td>
<td>Post a message on the mailing list.</td></tr>


</table>

<p>&nbsp;<br>
<a name=commonp></a>

<b><font face="Arial, Helvetica" color="#003366">Here are some commonly
 reported problems (</font>
 <font face="Arial, Helvetica" color="#009999">P:</font>
 <font face="Arial, Helvetica" color="#003366">) and their solutions (</font>
 <font face="Arial, Helvetica" color="#FF0099">S:</font>
 <font face="Arial, Helvetica" color="#003366">).</font></b>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I ran my program with <font color="#993333"><b>exw</b></font>
   and the console window disappeared before I could read the output.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>The console window will only appear if required, and will
   disappear immediately when your program finishes execution. Perhaps you
   should code something like:
</td></tr>


<tr><td></td><td>
<pre><font color="#FF00FF">        puts</font><font color="#330033">(1, </font><font color="#00A033">"\nPress Enter\n"</font><font color="#330033">)</font>
<font color="#0000FF">        if </font><font color="#FF00FF">getc</font><font color="#330033">(0) </font><font color="#0000FF">then</font>
<font color="#0000FF">        end if</font>
</pre></td></tr>


<tr><td valign=top><b></b></td>
<td>at the end of your program.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>At the end of execution of my program, I see "Press Enter"
  and I have to hit the Enter key. How do I get rid of that?
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Call free_console() just before your program terminates.
</td></tr>


<tr><td></td><td>
<pre><font color="#0000FF">        include </font><font color="#330033">dll.e</font>
<font color="#330033">        </font>
<font color="#330033">        free_console()</font>
</pre></td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I would like to change the properties of the console window.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Right click on <b>c:\windows\system\conagent.exe</b> and
   select "properties". You can change the font and several other items.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>When I run <font color="#993333"><b>ex.exe</b></font> in
   a DOS Window, it makes my small DOS window go to full screen.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>This will only happen the first time you run
   <font color="#993333"><b>ex.exe</b></font> after creating a new small
   DOS window. You can make the window small again by pressing
   <b>Alt-Enter</b>. It will stay small after that. Your Euphoria program
   can keep the window small by executing:
</td></tr>


<tr><td></td><td>
<pre><font color="#0000FF">        if </font><font color="#330033">graphics_mode(-1) </font><font color="#0000FF">then</font>
<font color="#0000FF">        end if</font>
</pre></td></tr>

 
<tr><td valign=top><b></b></td>
<td>at the start of execution. This may cause some brief screen
   flicker. Your program can force a text window to be full-screen 
   by executing:
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">        if </font><font color="#330033">graphics_mode(3) </font><font color="#0000FF">then</font>
<font color="#0000FF">        end if</font>
</pre></td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>My Euphoria CGI program hangs or has no output
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Look for an ex.err file in your cgi-bin directory. 
  Turn on <b>with trace</b> / <b>trace(3)</b> to see what statements
  are executed (see ctrace.out in your cgi-bin). Insert 
  <b>without warning</b> at the top of your program.
   On Windows, when there are warnings, Euphoria will issue a prompt 
   before terminating, causing your program to hang. On Windows you should 
   always use <b>exwc.exe</b> to run CGI programs, or you may have problems with
   standard output. With Apache Web Server, you
   can have a first line in your program of: #!.\exwc.exe to run your program
   using exwc.exe in the current (cgi-bin) directory. On Linux/FreeBSD, 
   be careful that your first line ends in LF, not CR-LF, or the #! won't
   be handled correctly. On Linux you must also set the execute permissions
   on your program correctly, and ex.err and ctrace.out must be 
   writable by the server process or they won't be updated. See
   <a href=cgi.htm>cgi.htm</a> for more
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>How do I read/write ports?
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Get <b>Jacques Deschenes</b>' collection of machine-level and
   DOS system routines from the
   <a href="http://www.RapidEuphoria.com">Euphoria Web page</a>. See his
   file <b>ports.e</b>.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I'm having trouble running a
   <font color="#CC3366"><b>DOS32</b></font> graphics program. I hit
   control-Break and now my system seems to be dead.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Some graphics programs will not run unless you start them from
   DOS or from a full-screen DOS window under Windows. Sometimes you
   have to edit the program source to use a lower resolution graphics mode,
   such as mode 18. Some SVGA graphics modes might not work for you under a
   DOS window, but will work when you restart your machine in
   MS-DOS mode. A better driver for your video card might fix this.
   <p>
   You should stop a program using the method that the program documentation
   recommends. If you abort a program with control-c or control-Break you may
   find that your screen is left in a funny graphics mode using funny colors.
   When you type something, it may be difficult or even impossible to read
   what you are typing. <i>The system may even appear dead, when in fact it
   is <b>not</b></i>.
   <p>
   Try the following DOS commands, in the following order, until you clear
   things up:
   <p>
      1. type: Alt-Enter to get a normal (non-full-screen) window again.
   
   <p>
      2. type: <b>cls</b><br>
         Even when you can't see any keystrokes echoed on the screen
         this may clear the screen for you.
   <p>
      3. type: <b>ex</b><br>
         The Euphoria interpreter will try to restore a normal
         <font color="#CC3366">text mode</font> screen for you.
   <p>
      4. type: <b>exit</b><br>
         If you are running under Windows, this will terminate the
         DOS session for you.
   <p>
      5. type: <b>Control-Alt-Delete</b><br>
         This will let you kill the current DOS session under Windows,
         or will soft-reboot your computer if you are running under DOS.
   <p>
      6. If all else fails, reset or power your computer off and back on.
         You should immediately run <b>scandisk</b> when the system
         comes back up.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>When I run Euphoria programs in SVGA, the output on the screen
   is crammed into the top part of the screen.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Try: <font color="#006699"><b>use_vesa(1)</b></font> in
   <font color="#5500FF"><b>machine.e</b></font>.
   <p>
   Try downloading the latest driver for your video card from the Internet.
   ATI's site is:
   <p>
   <a href="http://www.atitech.com">http://www.atitech.com</a>
   <p>
   Others have had their video problems clear up after installing the latest
   version of DirectX.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>My program leaves the DOS window in a messy
   state. I want it to leave me with a normal text window.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>When your program is finished, it should call the function
  graphics_mode(-1) to set the DOS window back to normal. e.g.
</td></tr>

<tr><td></td><td>
<pre><font color="#0000FF">        if </font><font color="#330033">graphics_mode(-1) </font><font color="#0000FF">then</font>
<font color="#0000FF">        end if</font>
</pre></td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>When I run my program from the editor and I hit control-c,
   the program dies with an operating system error.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>This is a known problem. Run your program from the command-line,
   outside the editor, if you might have to hit control-c or control-Break.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>When I run my program there are no errors but nothing happens.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>You probably forgot to call your main procedure. You need
   a top-level statement that comes after your main procedure to call the
   main procedure and start execution.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I'm trying to call a routine documented in
   <font color="#5500FF"><b>library.doc</b></font>, but it keeps saying
   the routine has not been declared.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Did you remember to include the necessary <b>.e</b> file from
   the <font color="#5500FF"><b>euphoria\include</b></font> directory? If
   the syntax of the routine says for example, "include graphics.e", then
   your program must have "<b>include graphics.e</b>" (without the quotes)
   before the place where you first call the routine.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I have an include file with a routine in it that I want to
   call, but when I try to call the routine it says the routine has not been
   declared. But it <b><i>has</i></b> been declared.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Did you remember to define the routine with
   "<b>global</b>" in front of it in the include file? Without "global"
   the routine is not visible <i><b>outside</b></i> of its own file.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>How do I input a line of text from the user?
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>See <font color="#006699"><b>gets()</b></font> in
   <a class="blue" href="lib_e_g.htm#gets"><b>library.doc</b></a>.
   <font color="#006699">gets(0)</font> will read a line from <b>standard
   input</b>, which is normally the <b>keyboard</b>. The line will always
   have <b>\n</b> on the end. To remove the trailing \n character do:
</td></tr>


<tr><td></td><td>
<pre><font color="#330033">        line = line[1..</font><font color="#FF00FF">length</font><font color="#993333">(</font><font color="#330033">line</font><font color="#993333">)</font><font color="#330033">-1]</font>
</pre></td></tr>


<tr><td valign=top><b></b></td>
<td>Also see <font color="#006699"><b>prompt_string()</b></font>
   in <font color="#5500FF"><b>get.e</b></font>.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>After inputting a string from the user with
   <font color="#006699"><b>gets()</b></font>, the next line that comes
   out on the screen does not start at the left margin.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Your program should output a <i>new-line</i> character e.g.
   <font color="#006699"><b>puts(SCREEN, '\n')</b></font> after you do a
   <font color="#006699">gets()</font>. It does not happen automatically.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>Why aren't my floating-point calculations coming out exact?
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Intel CPU's, and most other CPU's, use binary numbers
  to represent fractions. Decimal fractions such as 0.1, 0.01 and 
  similar numbers can't be represented precisely. For example, 0.1 might
  be stored internally as 0.0999999999999999. That means that 10 * 0.1
  might come out as 0.999999999999999, and floor(10 * 0.1) might be 0,
  not 1 as you'd expect. This can be a nuisance when you are dealing
  with money calculations, but it's not a Euphoria problem. It's a
  general problem that you must face in most programming languages.
  Always remember: floating-point numbers are just an approximation
  to the "real" numbers in mathematics. Assume that any floating-point calculation
  might have a tiny bit of error in the result. Sometimes you can
  solve the problem by rounding, e.g. x = floor(x + 0.5) would round
  x off to the nearest integer. Storing money values as an integer 
  number of pennies, rather than a fractional number of dollars 
  (or similar currency) will help, but some calculations could still 
  cause problems.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>How do I convert a number to a string?
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Use <font color="#006699"><b>sprintf()</b></font> in
   <font color="#5500FF"><b>library.doc</b></font>. e.g.
</td></tr>


<tr><td></td><td>
<pre><font color="#330033">        string = </font><font color="#FF00FF">sprintf</font><font color="#330033">(</font><font color="#00A033">"%d"</font><font color="#330033">, number)</font>
</pre></td></tr>


<tr><td valign=top><b></b></td>
<td>Besides <b>%d</b>, you can also try other formats, such as
   <b>%x</b> (Hex) or <b>%f</b> (floating-point).
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>How do I convert a string to a number?
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Use <font color="#006699"><b>value()</b></font> in
   <font color="#5500FF"><b>library.doc</b></font>, or, if you are reading
   from a file or the keyboard, use
   <font color="#006699"><b>get()</b></font>.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>It says I'm attempting to redefine my for-loop variable.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>For-loop variables are declared automatically.
   Apparently you already have a declaration with the same name earlier in
   your routine or your program. Remove that earlier declaration or change
   the name of your loop variable.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I get the message "unknown escape character" on a line
   where I am trying to specify a file name.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td><b><i>Do not</i></b> say "C:\TMP\MYFILE". You need to say
   <b>"C:\\TMP\\MYFILE"</b>. Backslash is used for escape characters such
   as <b>\n</b> or <b>\t</b>. To specify a single backslash in a string you
   need to type <b>\\</b>.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I'm trying to use mouse input in a SVGA graphics mode but it
   just doesn't work.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td><font color="#CC3366"><b>DOS</b></font> does not support
   mouse input in modes beyond graphics mode 18 (640x480 16 color).
   <font color="#CC3366"><b>DOS 7.0 (part of Windows 95/98)</b></font> does
   seem to let you at least read the x-y coordinate and the buttons in high
   resolution modes, but you may have to draw your own mouse pointer in the
   high-res modes. <b>Graeme Burke</b>, <b>Peter Blue</b> and others have good
   solutions to this problem. See their files on the
   <a href="http://www.RapidEuphoria.com/archive.htm">Euphoria Archive
   Web page</a>.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I'm trying to print a string using
   <font color="#006699"><b>printf()</b></font> but only the first character
   comes out.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>See the <font color="#006699"><b>printf()</b></font>
   description in <font color="#5500FF"><b>library.doc</b></font>. You may
   need to put braces around your string so it is seen as a single value to
   be printed, e.g. you wrote:
</td></tr>


<tr><td></td><td>
<pre><font color="#FF00FF">        printf</font><font color="#330033">(1, </font><font color="#00A033">"Hello %s"</font><font color="#330033">, mystring)</font>
</pre></td></tr>


<tr><td valign=top><b></b></td>
<td>where you should have said:
</td></tr>


<tr><td></td><td>
<pre><font color="#FF00FF">        printf</font><font color="#330033">(1, </font><font color="#00A033">"Hello %s"</font><font color="#330033">, </font><font color="#993333">{</font><font color="#330033">mystring</font><font color="#993333">}</font><font color="#330033">)</font>
</pre></td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>When I print numbers using
   <font color="#006699"><b>print()</b></font> or
   <font color="#006699"><b>?</b></font>, only 10 significant digits are
   displayed.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Euphoria normally only shows about 10 digits. Internally, all
   calculations are performed using at least 15 significant digits. To see
   more digits you have to use <font color="#006699"><b>printf()</b></font>.
   For example,
</td></tr>


<tr><td></td><td>
<pre><font color="#FF00FF">        printf</font><font color="#330033">(1, </font><font color="#00A033">"%.15f"</font><font color="#330033">, 1/3)</font>
</pre></td></tr>


<tr><td valign=top><b></b></td>
<td>This will display 15 digits.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>It complains about my routine declaration, saying "a type is
   expected here".
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>When declaring subroutine parameters, Euphoria requires you to
   provide an explicit type for each individual parameter. e.g.
</td></tr>


<tr><td></td><td>
<pre><font color="#0000FF">        procedure </font><font color="#330033">foo(</font><font color="#FF00FF">integer </font><font color="#330033">x, y)         </font><font color="#FF0055">-- WRONG</font>
<font color="#0000FF">        procedure </font><font color="#330033">foo(</font><font color="#FF00FF">integer </font><font color="#330033">x, </font><font color="#FF00FF">integer </font><font color="#330033">y) </font><font color="#FF0055">-- RIGHT</font>
</pre></td></tr>


<tr><td valign=top><b></b></td>
<td>In all other contexts it is ok to make a list:
</td></tr>


<tr><td></td><td>
<pre><font color="#FF00FF">        atom </font><font color="#330033">a, b, c, d, e</font>
</pre></td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I'm declaring some variables in the middle of a routine and
   it gives me a syntax error.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>All of your <i>private</i> variable declarations must come
   at the beginning of your <b>subroutine</b>, before any executable
   statements. (At the top-level of a program, <b>outside of any routine</b>,
   it is ok to declare variables anywhere.)
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>It says:<br>
   Syntax Error - expected to see possibly 'xxx', not 'yyy'
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>At this point in your program you have typed a variable,
   keyword, number or punctuation symbol, yyy, that does not fit syntactically
   with what has come before it. The compiler is offering you one example,
   xxx, of something that would be accepted at this point in place of yyy.
   Note that there may be many other legal (and much better) possibilities
   at this point than xxx, but xxx might at least give you a clue as to what
   the compiler is "thinking".
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I'm having problems running Euphoria with DR-DOS.
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td>Your <b>config.sys</b> should have just HIMEM.SYS but not
   EMM386.EXE in it.
</td></tr>


</table>

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#009999">P:</font></b></td>
<td>I try to run a program with
   <font color="#993333"><b>exw</b></font> and it says "this is a Windows
   NT character-mode executable".
</td></tr>


<tr><td valign=top><b><font color="#FF0099">S:</font></b></td>
<td><font color="#993333"><b>exw.exe</b></font> is a
   <font color="#CC3366"><b>32-bit Windows program</b></font>. It must be
   run under Windows or in a DOS Window. It will not work under 
   plain DOS in an old system.
   <font color="#993333"><b>ex.exe</b></font> <b><i>will</i></b> work under
   <font color="#CC3366"><b>plain DOS</b></font>.
</td></tr>


</table>


<p>&nbsp;

</td></tr></table>

</body>
</html>

